# coding: utf-8

"""
    IdentityNow Beta API

    Use these APIs to interact with the IdentityNow platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from sailpoint.beta.models.context_attribute_dto import ContextAttributeDto
from sailpoint.beta.models.role_match_dto import RoleMatchDto
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class AccessRequestContext(BaseModel):
    """
    AccessRequestContext
    """ # noqa: E501
    requested_context: Optional[List[ContextAttributeDto]] = Field(default=None, alias="requestedContext")
    assigned_context: Optional[List[RoleMatchDto]] = Field(default=None, alias="assignedContext")
    __properties: ClassVar[List[str]] = ["requestedContext", "assignedContext"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AccessRequestContext from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in requested_context (list)
        _items = []
        if self.requested_context:
            for _item in self.requested_context:
                if _item:
                    _items.append(_item.to_dict())
            _dict['requestedContext'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in assigned_context (list)
        _items = []
        if self.assigned_context:
            for _item in self.assigned_context:
                if _item:
                    _items.append(_item.to_dict())
            _dict['assignedContext'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of AccessRequestContext from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "requestedContext": [ContextAttributeDto.from_dict(_item) for _item in obj.get("requestedContext")] if obj.get("requestedContext") is not None else None,
            "assignedContext": [RoleMatchDto.from_dict(_item) for _item in obj.get("assignedContext")] if obj.get("assignedContext") is not None else None
        })
        return _obj


